" General Configurations (Any language/Tool)

" Stripping trailing whitespace on save
autocmd BufWritePre * :%s/\s\+$//e

" Standard variables
set expandtab                  " tabs to spaces
set tabstop=2                  " spaces entered when tab key is pressed
set shiftwidth=2               " spaces entered for indentation
set number                     " Line numbering
set clipboard+=unnamedplus     " Share system clipboard
set eol                        " End of line at bottom of file
set shiftround
set list
set list listchars=tab:»·,trail:·
