" Initialization

let g:nvim_config_root = stdpath('config')

exe 'source' g:nvim_config_root . '/conf/plugins.vim'
exe 'source' g:nvim_config_root . '/conf/keybinds.vim'
exe 'source' g:nvim_config_root . '/conf/config.vim'
exe 'source' g:nvim_config_root . '/conf/ui.vim'
exe 'source' g:nvim_config_root . '/conf/search.vim'
exe 'source' g:nvim_config_root . '/conf/git.vim'

let lang_configs = glob(g:nvim_config_root . '/conf/langs/*.vim', 1, 1)

for lang_config in lang_configs
  exe 'source' lang_config
endfor

